/**
Vier Gewinnt properties
 */
public class VP{
    public final static String VERSION = "1.11";
    //-- changing MAXCOLUMNS or MAXROWS to values != 8, may 
    //-- leads to inconsistencies. so first run VierGewinntTester
    //-- if you don't know what you are doing
    //for debugging purposes, should be 8 in the release
    public final static int MAXCOLUMNS = 4;
    //for debugging, should be 8 for the release version
    public final static int MAXROWS = 4;
    //the maximum number of turns
    //    public final static int MAXTURNDEPTH = MAXCOLUMNS*MAXROWS/2;
    public final static int MAXTURNDEPTH = MAXCOLUMNS*MAXROWS;
    //public final static int MAXTURNDEPTH = 7;


    //debug information
    //Output every move
    public final static boolean OUTPUTALL = false;
    //only the winning moves
    public final static boolean OUTPUTWON = false || OUTPUTALL;

    //some java implementations and database drivers can't
    //cope with the multithreaded version
    public final static boolean MULTITHREADED = true; 

    //indicates that the programm doesn't store the turns in memory
    //but in a database via JDBC
    //edit VierGewinntDB.java for database configuration
    public final static boolean USEDATABASE = false;
    //Output some statics about database performance
    public final static boolean OUTPUTDBSTATS = true;
    //the maximum number of results in a database query
    public final static int MAXDBFETCH = 20000;
    //the maximum number of values to store in one session
    public final static int MAXDBSTORE = 1000;
    //the number of elements to keep in the cache
    public final static int DBCACHESIZE = 100000;

    //The Strings to connect to the different databases
    public final static String[] CONNECTIONSTRINGS = {
	//"jdbc:mysql://localhost/VierGewinntTurns",
	"jdbc:mysql://10.8.112.12/VierGewinntTurns?user=VierGewinntUser&password=dsjhkhjk&autoReconnect=true",
	"jdbc:mysql://10.8.112.13/VierGewinntTurns?user=VierGewinntUser&password=hjgjhgkj&autoReconnect=true"
    };


    static{
	//Load the database drivers
	if(USEDATABASE){
		try {
	    //mysql
	    Class.forName("org.gjt.mm.mysql.Driver"); 
	    //ODBC
//	    Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		}catch(ClassNotFoundException e){
	    e.printStackTrace();
	    System.exit(-1);
		}
	}
    }

    //indicates that the tree should be stored in memory, default = true
    //false means that every part of the tree that is no longer
    //needed will be removed
    //STORETREE cannot be used as long as the turns are stored in a HashSet.
    //They must be stored in a HashMap. Also a line must be added to
    //get the object out of the Hashmap when it was already in there
    //to reuse the old one for the tree.
    public final static boolean STORETREE = false;
    //Don't calculate symmetric turns twice, i.e.
    //one red in the leftmost column is the same turn
    //as one red in the rightmost column
    public final static boolean USESYMMETRY = true;
    //Don't store turns that are not plausible
    //e.g., Player one has three chips in a row and needs only
    //one to win, he would be dump, if he would insert the chip in the
    //wrong column. All positions with the wrong colum are not count
    //then.
    public final static boolean STOREDUMBTURNS = false;


    //optimize classes for speed (don't check for valid parameters)
    public final static boolean SPEEDOPTIMIZED = true;

    public static String timeToString(long time){
	long ms = time % 1000;
	time /= 1000;
	long s = time % 60;
	time /= 60;
	long m = time % 60;
	time /= 60;
	long h = time %24;
	time /= 24;
	long d = time;
	return (d+" days, "+h+" h, "+m+" min, "
		     +s+" sec, "+ms+" ms");
    }
}
