public class VierGewinntTester{
    private static int MAXLOOPCOUNT = 500;

    public static void main(String[] args){
	//tempTest();
	if(VP.USESYMMETRY)
	    throw new RuntimeException("VP.USESYMMETRY must be "
				       +"false in this version");
	colTest();
	rowTest();
	//diagonalTest();
	equalsTest(false);
	if(VP.USESYMMETRY)
	    equalsTest(true);
    }

    private static void equalsTest(boolean useSymetry){
	VierGewinntTurn t1 = new VierGewinntTurn();
	VierGewinntTurn t2 = new VierGewinntTurn();
	
	if(useSymetry)
	    System.out.print("Testing for symetric equality... ");
	 else System.out.print("Testing for equality... ");
	
	boolean first = false;
	newStart: for(int i=0;i<MAXLOOPCOUNT;i++){
	    t1 = new VierGewinntTurn();
	    t2 = new VierGewinntTurn();


	    for(int a=randTurnDepth();a!=0;a--){
		first = !first;
		
		int col = randMaxCol();
		int col1, col2;
		col1 = col;
		col2 = col;

		if(t1.columnHasSpace(col1)!=t2.columnHasSpace(col2))
		    pf(t1,t2);

		if(t1.columnHasSpace(col1)){
		    if(first){
			t1 = nextFirst(t1,col1);
			t2 = nextFirst(t2,col2);
		    }else{
			t1 = nextSecond(t1,col1);
			t2 = nextSecond(t2,col2);
		    }

		}        
		   
		if(!t1.equals(t2))
		    pf(t1,t2);
		if(!t2.equals(t1))
		    pf(t1,t2);

		if(t1.hashCode()!=t2.hashCode())
		    pf(t1,t2);

		if(t1.getWinner()!=t2.getWinner())
		    pf(t1,t2);
		
		if(t1.getWinner()!=t1.NOBODY)
		    continue newStart;

	    }

	    //make it unequal
	    int col = randMaxCol();
	    if(t1.columnHasSpace(col)){
		if(first)
		    t1 = nextFirst(t1,col);
		else t1 = nextSecond(t1,col);
		if(t1.equals(t2))
		    pf(t1,t2);
		if(t2.equals(t1))
		    pf(t1,t2);
	    }
	}
	pp();
    }

    private static void colTest(){
	VierGewinntTurn t = new VierGewinntTurn();
	System.out.print("Testing for columns... ");
	final int MAXCOL = VP.USESYMMETRY?(VP.MAXCOLUMNS+1)/2:VP.MAXCOLUMNS;
	for(int i=0;i<MAXCOL;i++){
	    t = new VierGewinntTurn();
	    for(int a=0;a<3;a++){
		t = nextFirst(t,i);
		if(t.getWinner()!=t.NOBODY)
		    pf(t);
		t = nextSecond(t,VP.MAXCOLUMNS-i-1);
		if(t.getWinner()!=t.NOBODY)
		    pf(t);
	    }
 	    t = nextFirst(t,i);
	    if(t.getWinner()!=t.FIRSTPLAYER)
		pf(t);
	}

	pp();
    }

    private static void rowTest(){
	VierGewinntTurn t = new VierGewinntTurn();
	System.out.print("Testing for rows... ");
	
	for(int i=0;i<VP.MAXCOLUMNS-3;i++){
	    t = new VierGewinntTurn();
	    for(int a=0;a<3;a++){
		t = nextFirst(t,i+a);
		if(t.getWinner()!=t.NOBODY)
		    pf(t);
		t = nextSecond(t,i+a);
		if(t.getWinner()!=t.NOBODY)
		    pf(t);
	    }
	    t = nextFirst(t,i+3);
	    if(t.getWinner()!=t.FIRSTPLAYER)
		pf(t);
	}
	pp();
    }

    private static void diagonalTest(){
	VierGewinntTurn t= new VierGewinntTurn();
	
	System.out.print("Testing for diagonal... ");
	
	for(int i=0;i<VP.MAXCOLUMNS-3;i++){
	    t = new VierGewinntTurn();
	    int firstCount = 0;
	    int secondCount = 0;
	    
	    for(int a=0;a<4;a++){
		for(int b=0;b<3-a;b++){
		    t = nextFirst(t,i+a);
		    firstCount++;
		}
		if(t.getWinner()!=t.NOBODY)
		    pf(t);
		t = nextSecond(t,i+a);
		secondCount++;
		if(a<2 && t.getWinner()!=t.NOBODY)
		    pf(t);
	    }

	    if(t.getWinner()!=t.SECONDPLAYER)
		pf(t);
	}

	for(int i=0;i<VP.MAXCOLUMNS-3;i++){
	    t = new VierGewinntTurn();

	    for(int a=0;a<4;a++){
		for(int b=0;b<a;b++)
		    t = nextSecond(t,i+a);
		if(t.getWinner()!=t.NOBODY)
		    pf(t);
		t = nextFirst(t,i+a);
		if(a<2 && t.getWinner()!=t.NOBODY)
		    pf(t);
	    }
	    if(t.getWinner()!=t.FIRSTPLAYER)
		pf(t);
	}
	

	pp();

    }

    private static VierGewinntTurn nextFirst(VierGewinntTurn t, int col){
	return nextTurn(t,VierGewinntTurn.FIRSTPLAYER,col);
    }

    private static VierGewinntTurn nextSecond(VierGewinntTurn t, int col){
	return nextTurn(t,VierGewinntTurn.SECONDPLAYER,col);
    }

    private static void pp(){
	System.out.println("passed");
    }

    private static void pf(VierGewinntTurn t1, VierGewinntTurn t2){
	System.out.println('\n'+t1.toString());
	pf(t2);
    }
    private static void pf(VierGewinntTurn t){
 	System.out.println('\n'+t.toString());
	System.out.println("failed\n");
	throw new RuntimeException("Test failed, exiting");
    }

    private static int randMaxCol(){
	return (int)(Math.random()*VP.MAXCOLUMNS);
    }

    private static int randTurnDepth(){
	return (int)(Math.random()*VP.MAXTURNDEPTH);
    }
   
    private static void tempTest(){
	VierGewinntTurn t1 = new VierGewinntTurn();
	VierGewinntTurn t2 = new VierGewinntTurn();
	
	System.exit(0);
    }
    private static VierGewinntTurn nextTurn(VierGewinntTurn t, 
					    int player, int col){
	VierGewinntTurn ret =  
	    new VierGewinntTurn(t,player,col);
	//	System.out.println(ret.toString());
	return ret;
    }
   
}

